/*******************************************************************************
*                                                                              *
*    Leibniz Institute on Aging - Fritz Lipmann Institute                      *
*    Genomic Ananlysis                                                         *
*                                                                              *
*    niels jahn	                                                               *
*    2014,2015                                                                 *
*                                                                              *
*******************************************************************************/

#include "expand_iupac.h"
#include <stdexcept>
#include <map>
#include <set>

using namespace std;

list<string> add_list(const list<string> &s1,const list<string> &s2)
{	list<string> ret(s1);
	for (list<string>::const_iterator i=s2.begin(); i!=s2.end(); ++i)
	{	ret.push_back(*i);
	}
	return ret;
}	

set<char> valid;

map<char,set<char> >	codes;

/*{
{'R',{'A','G'} },
{'Y',{'C','T'} },
{'S',{'G','C'} },
{'W',{'A','T'} },
{'K',{'G','T'} },
{'M',{'A','C'} },

{'B',{'C','G','T'} },
{'D',{'A','G','T'} },
{'H',{'A','C','T'} },
{'V',{'A','C','G'} },

{'N',{'A','C','G','T'} },
}*/;

static class init
{	public:
	init()
	{	valid.insert('A');
		valid.insert('C');
		valid.insert('G');
		valid.insert('T');
		codes['R'].insert('A');
		codes['R'].insert('G');

		codes['Y'].insert('C');
		codes['Y'].insert('T');

		codes['S'].insert('G');
		codes['S'].insert('C');

		codes['W'].insert('A');
		codes['W'].insert('T');

		codes['K'].insert('G');
		codes['K'].insert('T');

		codes['M'].insert('A');
		codes['M'].insert('C');

		codes['B'].insert('C');
		codes['B'].insert('G');
		codes['B'].insert('T');

		codes['D'].insert('A');
		codes['D'].insert('G');
		codes['D'].insert('T');

		codes['H'].insert('A');
		codes['H'].insert('C');
		codes['H'].insert('T');

		codes['V'].insert('A');
		codes['V'].insert('C');
		codes['V'].insert('G');

		codes['N'].insert('A');
		codes['N'].insert('C');
		codes['N'].insert('G');
		codes['N'].insert('T');
	}
} static_init;	

static class add_lower_case
{	public:
	add_lower_case()
	{	for (set<char>::iterator i=valid.begin(); i!=valid.end(); ++i)
		{	valid.insert(tolower(*i));
		}
		for (map<char,set<char> >::iterator i=codes.begin(); i!=codes.end(); ++i)
		{	for (set<char>::iterator j=i->second.begin(); j!=i->second.end(); ++j)
			{	codes[tolower(i->first)].insert(tolower(*j));
			}
		}
	}
} auto_init;

list<string> expand_iupac(const string &s)
{	list<string>	ret;
	for (unsigned int i=0; i<s.size(); ++i)
	{	if (valid.find(s[i])!=valid.end())
		{	continue;
		}
		map<char,set<char> >::iterator j=codes.find(s[i]);
		if (j!=codes.end())
		{	
			for (set<char>::iterator k=j->second.begin(); k!=j->second.end(); ++k)
			{	string h(s);
				h[i]=*k;
				ret=add_list(ret,expand_iupac(h));
			}
			return ret;
		}
		else
		{	throw runtime_error("expand_iupac: unhandled char '"+string(1,s[i])+"'");
		}
	}
	ret.push_back(s);
	return ret;
}

