/*******************************************************************************
*                                                                              *
*    Leibniz Institute on Aging - Fritz Lipmann Institute                      *
*    Genomic Ananlysis                                                         *
*                                                                              *
*    niels jahn	                                                               *
*    2014,2015                                                                 *
*                                                                              *
*******************************************************************************/

#include "match_iupac.h"
#include <stdexcept>

using namespace std;
using namespace boost;

iupac::iupac(const string &s)
{	for (size_t i=0; i<s.size(); ++i)
	{	switch (s[i])
		{	case 'a' :
				p+='a';	break;
			case 'c' :
				p+='c'; break;
			case 'g' :
				p+='g'; break;
			case 't' :
				p+='t'; break;

			case 'r' :
				p+="[ag]"; break;
			case 'y' :
				p+="[ct]"; break;
			case 's' :
				p+="[gc]"; break;
			case 'w' :
				p+="[at]"; break;
			case 'k' :
				p+="[gt]"; break;
			case 'm' :
				p+="[ac]"; break;

			case 'b' :
				p+="[cgt]"; break;
			case 'd' :
				p+="[agt]"; break;
			case 'h' :
				p+="[act]"; break;
			case 'v' :
				p+="[acg]"; break;

			case 'n' :
				p+="[acgt]";	break;
		
			case 'A' :
				p+='A';	break;
			case 'C' :
				p+='C'; break;
			case 'G' :
				p+='G'; break;
			case 'T' :
				p+='T'; break;

			case 'R' :
				p+="[AG]"; break;
			case 'Y' :
				p+="[CT]"; break;
			case 'S' :
				p+="[GC]"; break;
			case 'W' :
				p+="[AT]"; break;
			case 'K' :
				p+="[GT]"; break;
			case 'M' :
				p+="[AC]"; break;

			case 'B' :
				p+="[CGT]"; break;
			case 'D' :
				p+="[AGT]"; break;
			case 'H' :
				p+="[ACT]"; break;
			case 'V' :
				p+="[ACG]"; break;

			case 'N' :
				p+="[ACGT]";	break;
			default :
				throw runtime_error("iupac::iupac: not a iupac char '"+string(1,s[i])+"'");
				break;
		}
	}	
	pattern=boost::xpressive::sregex::compile(p);
}

ostream& operator << (ostream &o,const iupac &p)
{	return o << p.p;
}

static boost::xpressive::smatch what;

bool match_iupac(const string &s,const iupac &p)
{	return regex_match(s,what,p.pattern);
}


