/*******************************************************************************
*                                                                              *
*    Leibniz Institute on Aging - Fritz Lipmann Institute                      *
*    Genomic Ananlysis                                                         *
*                                                                              *
*    niels jahn	                                                               *
*    2014,2015                                                                 *
*                                                                              *
*******************************************************************************/

#ifndef _MATCH_IUPAC_H_
#define _MATCH_IUPAC_H_

#include <string>
#include <boost/xpressive/xpressive.hpp>
#include <iostream>

class iupac
{	std::string	p;
	boost::xpressive::sregex	pattern;
	public:
	iupac()
	:p(),pattern()
	{
	}
	iupac(const std::string&);
	size_t size() const
	{	return p.size();
	}
	friend std::ostream& operator << (std::ostream&,const iupac&);
	friend bool match_iupac(const std::string &s,const iupac&);
};	

std::ostream& operator << (std::ostream&,const iupac&);

bool match_iupac(const std::string &s,const iupac&);

#endif

