/*******************************************************************************
*                                                                              *
*    Leibniz Institute on Aging - Fritz Lipmann Institute                      *
*    Genomic Ananlysis                                                         *
*                                                                              *
*    niels jahn	                                                               *
*    2014,2015                                                                 *
*                                                                              *
*******************************************************************************/

#ifndef _SEARCH_AROUND_CLASS_H_
#define _SEARCH_AROUND_CLASS_H_

#include <string>
#include <list>
#include <iostream>
#include <map>

class search_around_class
{	
	size_t		before;
	size_t		after;
	std::list<std::string>	*data;
	bool		own_data;
	size_t		req_len;

	int		all_count_hits;
	std::map<int,int>	hits_per_read_histogram;
	
	struct hit
	{	int	count;
		std::string	replace;
		int	replace_count;
		hit()
		:count(0),replace(),replace_count(0)
		{
		}
	};

	std::map<std::string,hit>	hits;

	struct hit_sorter
	{	bool operator () (const std::pair<std::string,hit> &a,const std::pair<std::string,hit> &b)
		{	if (a.second.count==b.second.count)
			{       return a.first>b.first;
			}
			return a.second.count>b.second.count;
		}
	};	

	public:
	search_around_class(size_t,size_t);

	void use_data(std::list<std::string>&);
	void load_data_from_file(const std::string&);

	void search(const std::string&);
	void output(std::ostream&,bool pattern_hit_info,int max_hits,bool do_sort=true) const;

	static void validate_pattern(const std::string&);
};

#endif

